﻿using ZweiFenster.ViewModel;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using System.Windows.Media;
using ZweiFenster.View;
using ZweiFenster.Model;
using System.Data;
using System.Collections.ObjectModel;

namespace ZweiFenster.ViewModel
{
    public class ZweiFensterViewModel : INotifyPropertyChanged
    {
        Werte _w = new Werte();
        ViewFensterZwei _fensterZwei = null;

        #region Eigenschaften

        private ICommand _aktionButtonCommand;
        public ICommand AktionButtonCommand
        {
            get { return _aktionButtonCommand; }
            set { _aktionButtonCommand = value; }
        }

        private ICommand _setzenButtonCommand;
        public ICommand SetzenButtonCommand
        {
            get { return _setzenButtonCommand; }
            set { _setzenButtonCommand = value; }
        }

        private ICommand _zrButtonCommand;
        public ICommand ZrButtonCommand
        {
            get { return _zrButtonCommand; }
            set { _zrButtonCommand = value; }
        }

        // für die ListBox
        public string WertListBox
        {
            get { return _w.WertListBox; }
            set
            {
                _w.WertListBox = value;
                this.OnPropertyChanged("WertListBox");
            }
        }
		
        private int _selectedIndexListBox;
        public int SelectedIndexListBox
        {
            get { return _selectedIndexListBox; }
            set
            {
                _selectedIndexListBox = value;
                this.OnPropertyChanged("SelectedIndexListBox");
            }
        }

        // für die ComboBox
        public string WertComboBox
        {
            get { return _w.WertComboBox; }
            set
            {
                _w.WertComboBox = value;
                this.OnPropertyChanged("WertComboBox");
            }
        }
		
        private int _selectedIndexComboBox;
        public int SelectedIndexComboBox
        {
            get { return _selectedIndexComboBox; }
            set
            {
                _selectedIndexComboBox = value;
                this.OnPropertyChanged("SelectedIndexComboBox");
            }
        }

        // für die Check
        public bool WertCheck
        {
            get { return _w.WertCheckBox; }
            set
            {
                _w.WertCheckBox = value;
                this.OnPropertyChanged("WertCheck");
            }
        }

        // für das DataSet
        private System.Data.DataRowView _selectedArtikel;
        public System.Data.DataRowView SelectedArtikel
        {
            get { return _selectedArtikel; }
            set
            {
                _selectedArtikel = value;
                _w.WertDataSet = ""; // wichtig wenn null
                if(_selectedArtikel!=null)
                    _w.WertDataSet = _selectedArtikel.Row[0].ToString();
                OnPropertyChanged("SelectedArtikel");
            }
        }
		
        // füllt das Grid mit der Tabelle Artikel
        public DataView ViewTabelleArtikel
        { 
            get { return _w.GetListeArtikel().Tables["Artikel"].DefaultView; }
        }
		
        // für die Selection vom Model aus
        private int _selectedIndexDataSet;
        public int SelectedIndexDataSet
        {
            get { return _selectedIndexDataSet; }
            set
            {
                _selectedIndexDataSet = value;
                this.OnPropertyChanged("SelectedIndexDataSet");
            }
        }

        private string _ergebnis;
        public string Ergebnis
        {
            get { return this._ergebnis; }
            set
            {
                this._ergebnis = value;
                this.OnPropertyChanged("Ergebnis");
            }
        }

        // wichtig für die Befehle
        private bool _canExecute = true;
        public bool CanExecute
        {
            get { return this._canExecute; }
            set
            {
                if (this._canExecute == value)
                {
                    return;
                }
            this._canExecute = value;
            }
        }

        #endregion

        public ZweiFensterViewModel()
        {
            _aktionButtonCommand = new RelayCommand(Aktion, param => this._canExecute);
            _setzenButtonCommand = new RelayCommand(Setzen, param => this._canExecute);
            _zrButtonCommand = new RelayCommand(ZurueckReset, param => this._canExecute);
            Ergebnis = "Das steht drin";
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected internal void OnPropertyChanged(string propertyname)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new
                PropertyChangedEventArgs(propertyname));
        }

        private void Aktion(object obj)
        {
            string hilf = "true";

            try
            {
                _fensterZwei = new ViewFensterZwei();
                if (WertCheck == false)
                    hilf = "false";
                Ergebnis = "gewählt wurde: [ListBox]:" + this.WertListBox + 
                    ", [ComboBox]:" + this.WertComboBox + "," + Environment.NewLine +
                    "[DataSet]:"+ _w.WertDataSet+", [CheckBox]:"+hilf;
                // wichtig, ist zwar gebunden, sonst kommen die 
                // aktuellen Werte nicht mit
                _fensterZwei.DataContext = this;
                _fensterZwei.ShowDialog();
            }
            catch (Exception ex)
            {
                ;
            }
        }

        private void Setzen(object obj)
        {
            WertCheck = true;
            SelectedIndexListBox = 2;
            SelectedIndexComboBox = 1;
            SelectedIndexDataSet = 3;
        }

        private void ZurueckReset(object obj)
        {
            WertCheck = false;
            SelectedIndexListBox = 0;
            SelectedIndexComboBox = -1;
            SelectedIndexDataSet = -1;
            // nun das Fenster schließen
            this._fensterZwei.Close();
        }
    }
}
